Subject: mx6: suspicious RCU usage

From: [email-masked] (Paul E. McKenney)
Date: Tue, 14 Jul 2015 14:31:03 -0700

On Tue, Jul 14, 2015 at 09:49:09PM +0100, Russell King - ARM Linux wrote:
> On Tue, Jul 14, 2015 at 09:26:00AM -0700, Paul E. McKenney wrote:
> > On Tue, Jul 14, 2015 at 01:06:32PM -0300, Fabio Estevam wrote:
> > > Hi Paul,
> > > 
> > > On Tue, Jul 14, 2015 at 1:00 PM, Paul E. McKenney
> > > <[email-masked]> wrote:
> > > 
> > > > Does this patch help?
> > > >
> > > >         https://lkml.org/lkml/2015/5/12/885
> > > 
> > > I am using an ARM 32-bit machine, so I used this one instead:
> > > https://lkml.org/lkml/2015/5/12/892
> > > 
> > > , and it fixes the problem. Thanks!
> > > 
> > > Feel free to add:
> > > 
> > > Tested-by: Fabio Estevam <[email-masked]>
> > 
> > Glad it helped!
> > 
> > Russell, did you want me to push this, or would you rather take it?
> 
> If it's the one I'm thinking of (using the generic code) because it
> doesn't actually solve the problem we have.  It may shut up the RCU
> warning, but it doesn't solve the underlying problem - one which is
> caused by the use of atomics (which use the exclusive instructions)
> vs cache line migration between CPUs vs speculative prefetching...
> 
> It's possible right now that _dirty_ cache lines can be migrated to
> the dying CPU, which are then lost on power down - and if we disable
> the caches on the dying CPU, we then can't use exclusives, so atomics
> (and all of the other normal kernel synchronisation mechanisms) are
> out of the question.

OK, that could explain any number of failures.

I will leave this issue in your hands, then.

							Thanx, Paul